"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.MAX_NUMBER_OF_BYTE_U64 = exports.MAX_NUMBER_OF_BYTE_U32 = undefined;
exports.decodeInt64 = decodeInt64;
exports.decodeUInt64 = decodeUInt64;
exports.decodeInt32 = decodeInt32;
exports.decodeUInt32 = decodeUInt32;
exports.encodeU32 = encodeU32;
exports.encodeI32 = encodeI32;
exports.encodeI64 = encodeI64;

var _leb = require("./leb");

var _leb2 = _interopRequireDefault(_leb);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * According to https://webassembly.github.io/spec/core/binary/values.html#binary-int
 * max = ceil(32/7)
 */
var MAX_NUMBER_OF_BYTE_U32 = exports.MAX_NUMBER_OF_BYTE_U32 = 5;

/**
 * According to https://webassembly.github.io/spec/core/binary/values.html#binary-int
 * max = ceil(64/7)
 */


var MAX_NUMBER_OF_BYTE_U64 = exports.MAX_NUMBER_OF_BYTE_U64 = 10;

function decodeInt64(encodedBuffer, index) {
  return _leb2.default.decodeInt64(encodedBuffer, index);
}

function decodeUInt64(encodedBuffer, index) {
  return _leb2.default.decodeUInt64(encodedBuffer, index);
}

function decodeInt32(encodedBuffer, index) {
  return _leb2.default.decodeInt32(encodedBuffer, index);
}

function decodeUInt32(encodedBuffer, index) {
  return _leb2.default.decodeUInt32(encodedBuffer, index);
}

function encodeU32(v) {
  return _leb2.default.encodeUInt32(v);
}

function encodeI32(v) {
  return _leb2.default.encodeInt32(v);
}

function encodeI64(v) {
  return _leb2.default.encodeInt64(v);
}