"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (ast /*, moduleContext: Object */
) {
  var errors = [];

  (0, _ast.traverse)(ast, {
    ModuleImport: function ModuleImport(_ref) {
      var node = _ref.node;
      var mutability = node.descr.mutability;


      if (mutability === "var") {
        errors.push("mutable globals cannot be imported");
      }
    }
  });

  return errors;
};

var _ast = require("@webassemblyjs/ast");

module.exports = exports["default"];

/**
 * Determine if a sequence of instructions form a constant expression
 *
 * See https://webassembly.github.io/spec/core/multipage/valid/instructions.html#valid-constant
 */