"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createTrap = createTrap;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ExecutionHasBeenTrapped = exports.ExecutionHasBeenTrapped = function (_Error) {
  _inherits(ExecutionHasBeenTrapped, _Error);

  function ExecutionHasBeenTrapped() {
    _classCallCheck(this, ExecutionHasBeenTrapped);

    return _possibleConstructorReturn(this, (ExecutionHasBeenTrapped.__proto__ || Object.getPrototypeOf(ExecutionHasBeenTrapped)).apply(this, arguments));
  }

  return ExecutionHasBeenTrapped;
}(Error);

/**
 * Trap: signalling abrupt termination
 * https://webassembly.github.io/spec/core/exec/runtime.html#syntax-trap
 *
 * It triggered using the `trap` instruction
 */


function createTrap() {
  var reason = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : "Execution has been trapped";

  return new ExecutionHasBeenTrapped(reason);
}